package com.ann.entity.filing;

import lombok.Data;
import org.hibernate.annotations.GenericGenerator;

import javax.persistence.*;
import java.util.Date;

/**
 * @Description 患者清单详情 是 ArchiveMaster患者清单 从属关系
 * @Date 2019/7/9 10:07
 * @Created by  ljx
 */
@Data
@Entity
@Table
public class ArchiveDetail {

    @Id
    @GenericGenerator(name = "system-uuid", strategy = "uuid2")
    @GeneratedValue(generator = "system-uuid")
    private String id;

    private String pdfPath;

    // -----------------------绑定关系
    @Column(name = "masterid")
    private String masterID;

    @Column(name = "uploaddatetime")
    private Date upLoadDateTime;

    @Column(name = "assortid")
    private String assortID;

    private String source;

    @Column(name = "subassort")
    private String subAssort;

    private String title;

    private String flag = "0";

    private String sys;

    private Integer pageNumber = 1;
    /**
     * 扩展字段： 用于进行更新状态、与报告进行匹配
     * 2019-9-4
     */
    private String applyId;

    // 2020-12-28 新增报告单号
    private String checkReportId;

    public ArchiveDetail() {
    }

    public ArchiveDetail(String masterID, Date upLoadDateTime, String assortID, String source, String applyId) {
        this.masterID = masterID;
        this.upLoadDateTime = upLoadDateTime;
        this.assortID = assortID;
        this.source = source;
        this.applyId = applyId;
    }

    // lis系统下载
    public ArchiveDetail(String masterID, Date upLoadDateTime, String assortID, String source, String applyId,String checkReportId, String title) {
        this.masterID = masterID;
        this.upLoadDateTime = upLoadDateTime;
        this.assortID = assortID;
        this.source = source;
        this.checkReportId = checkReportId;
        this.title = title;
        this.applyId = applyId;
    }


    // 普通下载
    public ArchiveDetail(String masterID, Date upLoadDateTime, String assortID, String source, String applyId, String title,Integer i) {
        this.masterID = masterID;
        this.upLoadDateTime = upLoadDateTime;
        this.assortID = assortID;
        this.source = source;
        this.applyId = applyId;
        this.title = title;
    }

    //扫描下载
    public ArchiveDetail(String masterID, Date upLoadDateTime, String assortID, String source, String applyId, String pdfPath) {
        this.masterID = masterID;
        this.upLoadDateTime = upLoadDateTime;
        this.assortID = assortID;
        this.source = source;
        this.applyId = applyId;
        this.pdfPath = pdfPath;
    }
}
