package com.ann.entity.filing.dto;

import lombok.Data;

import java.util.Date;

/**
 * @Description
 * @Date 2019/7/9 16:50
 * @Created by  ljx
 */
@Data
public class MessageDto<T> {

    private String entity;

    private T object;

    private Date xmlCreateTime;

    private String type;

    private String inpNo;

    private String visitId;

    private String propertiesPath;

    private String reportAddress;

    // 2019-7-26 新增报告单号 考虑会传多次报告 但地址一样
    private String checkReportId;

    /**
     * 如果是入院信息 那么就会有新增 修改
     */
    private String addFlag;

    /**
     * 扩展字段： 用于进行更新状态、与报告进行匹配
     * 2019-9-4
     */
    private String applyId;

    // 2019-9-16 新增来源
    private String source;

    // 2019-10-21 新增排序时间
    private String captionDateTime;

    // 2019-11-28 新增三级标题
    private String detailType;

    //20200609 0是老数据 1是新数据
    private String isOld;

    /**
     * 电子病历最后提交时间
     * */
    private Date emrCommitTime;


    public MessageDto() {
    }

    public MessageDto(String entity, T object, String type, String propertiesPath) {
        this.entity = entity;
        this.object = object;
        this.type = type;
        this.propertiesPath = propertiesPath;
    }
}
