package com.ann.job;

import com.ann.service.ArchiveMasterService;
import com.ann.service.impl.GenerateService;
import com.ann.service.impl.QueueService;
import com.ann.utils.ExceptionPrintUtil;
import com.ann.utils.QuartzUtils;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.quartz.Scheduler;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * 取从属表报错的消息 次数小于6
 *
 * @Author: LeiJiaXin
 * @Date: 2019/8/16 10:12
 */
public class ScheduledJob4 implements Job {

    static final Logger logger = LoggerFactory.getLogger(ScheduledJob4.class);

    @Autowired
    Scheduler scheduler;

    @Autowired
    ArchiveMasterService archiveMasterService;

    @Autowired
    QueueService queueService;

    @Override
    public void execute(JobExecutionContext context) throws JobExecutionException {
        try {
            //System.out.println("动态的定时任务4执行时间：" + LocalTime.now());
            QuartzUtils.pauseScheduleJob(scheduler, "group1", "job4");
            queueService.doSomethingByHIS();
        } catch (Exception e) {
            ExceptionPrintUtil.printException(e);
            // 如果报错--  捕捉异常 继续执行
            logger.error("出错咯！错误信息为{}，以及错误行数为:{}" ,e,e.getStackTrace()[0]);
        }
        QuartzUtils.resumeScheduleJob(scheduler, "group1", "job4");
    }
}
