package com.ann.repository;

import com.ann.entity.filing.ArchiveDetail;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * @Author: LeiJiaXin
 * @Date: 2019/7/12 9:10
 */
@Repository
public interface ArchiveDetailRepository extends JpaRepository<ArchiveDetail, String> {

//    //  or Source = 'DoctorData' or AssortID = '117' or AssortID = '10' or AssortID = '60' or  AssortID = '57' or AssortID = '52' or AssortID = '54' or AssortID = '59'
//    @Query("select o from ArchiveDetail  o   ")
//    public List<ArchiveDetail> findAllHaha();

    @Query("select count (o) from ArchiveDetail  o where o.masterID = ?1 and o.assortID = ?2  and o.source=?3 and (o.applyId = ?4 and o.applyId is not null) and  o.flag = 0")
    Integer countByMasterIDAndAssortIDAndSourceAndApplyId(String masterId, String AssortID, String source, String applyId);

    @Query("select count (o) from ArchiveDetail  o where o.masterID = ?1 and o.assortID = ?2  and o.source=?3 and (o.checkReportId = ?4 and o.checkReportId is not null) and  o.flag = 0")
    Integer countByMasterIDAndAssortIDAndSourceAndCheckReportId(String masterId, String AssortID, String source, String CheckReportId);


    public ArchiveDetail findByMasterIDAndAssortIDAndSourceAndApplyIdAndFlag(String masterId, String AssortID, String source, String applyId,String flag);

    public ArchiveDetail findByMasterIDAndAssortIDAndSourceAndCheckReportIdAndFlag(String masterId, String AssortID, String source, String checkReportId,String flag);

    @Query("select count (o) from ArchiveDetail  o where o.masterID = ?1 and o.assortID = ?2  and o.title=?3 and  o.flag = 0 ")
    Integer countByMasterIDAndAssortIDAndTitleAndFlag(String masterId, String AssortID, String title);

//    @Query(value = "SELECT stuff(" +
//            "   (SELECT  ',' + CONVERT(VARCHAR,a.assort_name) " +
//            "        FROM zd_assort a WHERE a.assort_id in ?1  " +
//            "        and NOT EXISTS(SELECT id FROM archive_detail d WHERE  a.assort_id = d.AssortID  and  d.MasterID = ?2 ) " +
//            "    FOR XML PATH ('') " +
//            "    ),1,1,'') ", nativeQuery = true)
//    String getTypeNotExits(List<String> type, String masterId);

//    @Query(value = "SELECT stuff(" +
//            "   (SELECT  ',' + CONVERT(VARCHAR,a.assort_name) " +
//            "        FROM zd_assort a WHERE a.assort_id in ?1  " +
//            "        and NOT EXISTS(SELECT id FROM archive_detail d WHERE  a.assort_id = d.AssortID  and  d.MasterID = ?2 ) " +
//            "    FOR XML PATH ('') " +
//            "    ),1,1,'') ", nativeQuery = true)
//    String checkExamApply(String masterId);

//    @Query(value = " select * from archive_detail o where  o.MasterID in (select m.ID from archive_master m where " +
//            " m.dept_name  in(select code from emr_dictionary where name like ?1 ) and m.admission_Date_Time <= ?2 ) " +
//            " order by masterid,AssortID ",nativeQuery = true)
//    public List<ArchiveDetail> findArchiveDetail(String deptName,String admissionDateTime);
}
