package com.ann.repository;

import com.ann.entity.interfaceEntity.ArchiveMaster;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @Author: LeiJiaXin
 * @Date: 2019/7/11 20:55
 */
@Repository
public interface ArchiveMasterRepository extends JpaRepository<ArchiveMaster, String> {

    public ArchiveMaster findByInpNoAndVisitIdAndIsValid(String inpNo, String visitId, Integer isValid);


    @Query(value = "select o from ArchiveMaster o where (o.archiveState = '初审' or o.archiveState = '已归档') and (o.sendTime is null or o.sendTime = '') and o.inpNo not like '%LG%' and o.isValid = 0")
    public List<ArchiveMaster> findArchiveMasterBySendTime();

    @Transactional
    @Modifying
    @Query(value = "update ArchiveMaster o set o.sendTime = ?1 where (o.archiveState = '初审' or o.archiveState = '已归档') and o.id = ?2 and o.isValid = 0 and o.inpNo not like '%LG%' ")
    public Integer updateSendTime(String nowDate,String id);

    @Transactional
    @Modifying
    @Query(value = "update ArchiveMaster o set o.sendTime = null where o.archiveState = '复审退回' and o.id = ?1 and o.isValid = 0 ")
    public Integer updateSendTimeBySendBack(String id);

    @Query(value = "select o from ArchiveMaster o where (o.archiveState = '复审退回'  or o.archiveState = '主任退回' ) and o.sendTime is not null and o.inpNo not like '%LG%'")
    List<ArchiveMaster> findArchiveMasterBySendBackAndSendTime();
}
