package com.ann.service.impl;

import com.ann.entity.filing.ArchiveDetail;
import com.ann.repository.ArchiveDetailRepository;
import com.ann.service.ArchiveDetailService;
import com.ann.utils.FileUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.File;
import java.util.List;

/**
 * @Author: LeiJiaXin
 * @Date: 2019/7/12 9:12
 */
@Service
public class ArchiveDetailServiceImpl implements ArchiveDetailService {

    @Autowired
    ArchiveDetailRepository archiveDetailRepository;


    @Override
    public void save(ArchiveDetail archiveDetail) throws Exception{
        archiveDetailRepository.save(archiveDetail);
    }

    @Override
    public void delete(String id) throws Exception{
        archiveDetailRepository.deleteById(id);
    }


    @Override
    public ArchiveDetail isExit(String id, String type, String source, String applyId) throws Exception {
        if (archiveDetailRepository.countByMasterIDAndAssortIDAndSourceAndApplyId(id, type, source, applyId) > 0)
            return archiveDetailRepository.findByMasterIDAndAssortIDAndSourceAndApplyIdAndFlag(id, type, source, applyId,"0");
        return null;
    }

    @Override
    public ArchiveDetail isExitCheckReportId(String id, String type, String source, String checkReportId) throws Exception {
        if (archiveDetailRepository.countByMasterIDAndAssortIDAndSourceAndCheckReportId(id, type, source, checkReportId) > 0)
            return archiveDetailRepository.findByMasterIDAndAssortIDAndSourceAndCheckReportIdAndFlag(id, type, source, checkReportId,"0");
        return null;
    }

    @Override
    public Integer countByMasterIDAndAssortIDAndTitleAndFlag(String masterId, String AssortID,String title) throws Exception {
            return archiveDetailRepository.countByMasterIDAndAssortIDAndTitleAndFlag(masterId, AssortID, title);
    }

//    @Override
//    public String getTypeNotExits(List<String> type, String masterId) {
//        return archiveDetailRepository.getTypeNotExits(type, masterId);
//    }

//    @Override
//    public String checkExamApply(String masterId)throws Exception  {
//        return archiveDetailRepository.checkExamApply(masterId);
//    }

}
