package com.ann.service.impl;

import com.ann.entity.interfaceEntity.ArchiveMaster;
import com.ann.repository.ArchiveMasterRepository;
import com.ann.service.ArchiveMasterService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.util.List;

/**
 * @Author: LeiJiaXin
 * @Date: 2019/7/11 20:53
 */
@Service
public class ArchiveMasterServiceImpl implements ArchiveMasterService {

    @Autowired
    private ArchiveMasterRepository archiveMasterRepository;

    @Override
    public void save(ArchiveMaster archiveMaster) {
        archiveMasterRepository.save(archiveMaster);
    }

    @Override
    public ArchiveMaster findByInpNoAndVisitIdAndIsValid(String inpNo, String visitId) throws Exception {
        return archiveMasterRepository.findByInpNoAndVisitIdAndIsValid(inpNo, visitId, 0);
    }

    @Override
    public List<ArchiveMaster> findArchiveMasterBySendTime() {
        return archiveMasterRepository.findArchiveMasterBySendTime();
    }

    @Override
    public List<ArchiveMaster> findArchiveMasterBySendBackAndSendTime() {
        return archiveMasterRepository.findArchiveMasterBySendBackAndSendTime();
    }

    @Override
    public Integer updateSendTime(String id,String now,Integer isSign) {
        if(isSign == 0){
            return  archiveMasterRepository.updateSendTime(now, id);
        }
        else if(isSign == 1){
            return  archiveMasterRepository.updateSendTimeBySendBack(id);
        }
        return 1920;
    }


}
