package com.ann.utils;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import sun.net.ftp.FtpClient;
import sun.net.ftp.FtpProtocolException;

import java.io.*;
import java.net.InetSocketAddress;
import java.net.SocketAddress;
import java.util.Iterator;

/**
 * @Author: LeiJiaXin
 * @Date: 2019/7/24 9:49
 */
public class FtpUtils {

    static final Logger logger = LoggerFactory.getLogger(FtpUtils.class);

    public static FtpClient connectFTP(String url, int port, String username, String password) throws Exception {
        //创建ftp
        FtpClient ftp = null;
        try {
            //创建地址
            SocketAddress addr = new InetSocketAddress(url, port);
            //连接
            ftp = FtpClient.create();
            ftp.connect(addr);
            //登陆
            ftp.login(username, password.toCharArray());
            ftp.setBinaryType();
        } catch (FtpProtocolException e) {
            throw e;
        } catch (IOException e) {
            throw e;
        }
        return ftp;

    }
}

